﻿; ****************************************************************************************************
; PROJECT       : TUTO_POO
; PACKAGE       : TUTO_POO.controller
; DESIGNED WITH : PB 5.60
; NAME          : DrawingController
; VERSION       : 1
; DATE          :
; AUTHOR        : microdevWeb
; DESCRIPTION   : main window of software
; *****************************************************************************************************
DeclareModule DrawingController
  Enumeration 1
    #MODE_RECTANGLE
    #MODE_CIRCLE
    #MODE_SELECT
  EndEnumeration
  Global Mode
  Global drawing.Drawing::Drawing
  Declare eventCanvas()
  Declare draw(canvas=0)
  Declare delete()
EndDeclareModule
Module DrawingController
  EnableExplicit
  Global canvasId
  Global gMouseX,gMouseY
  Global gCurrentForm.Drawing::Form
  Procedure draw(canvas=0)
    If IsGadget(canvas)
      canvasId = canvas
    EndIf
    StartVectorDrawing(CanvasVectorOutput(canvasId))
    ; eraze the canvas
    VectorSourceColor($FFFFFFFF)
    FillVectorOutput()
    If drawing
      drawing\draw()
    EndIf
    StopVectorDrawing()
  EndProcedure
  
  Procedure eventCanvas()
    If Not IsGadget(canvasId) : ProcedureReturn : EndIf
    Select EventType()
      Case #PB_EventType_MouseEnter
        SetActiveGadget(canvasId)
      Case #PB_EventType_MouseMove
        gMouseX = GetGadgetAttribute(canvasId,#PB_Canvas_MouseX)
        gMouseY = GetGadgetAttribute(canvasId,#PB_Canvas_MouseY)
        If drawing\mouseIsOnForm(gMouseX,gMouseY)
          SetGadgetAttribute(canvasId,#PB_Canvas_Cursor,#PB_Cursor_Hand)
          ProcedureReturn 
        EndIf
        SetGadgetAttribute(canvasId,#PB_Canvas_Cursor,#PB_Cursor_Default)
      Case #PB_EventType_LeftClick
        Select Mode
          Case #MODE_CIRCLE
            drawing\addForm(fCircle::new(gMouseX,gMouseY,20))
            draw()
          Case #MODE_RECTANGLE
            drawing\addForm(Rectangle::new(gMouseX,gMouseY,50,50))
            draw()
          Case #MODE_SELECT
            ; Look, if the mouse is on a form
            gCurrentForm = drawing\mouseIsOnForm(gMouseX,gMouseY)
            If gCurrentForm
              ; we deselected all forms
              drawing\deselectAll()
              ; after that we select the specified form
              gCurrentForm\setSelected(#True)
              draw()
            EndIf
        EndSelect
    EndSelect
  EndProcedure
  
  Procedure delete()
    drawing\delete()
    draw()
  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; CursorPosition = 78
; FirstLine = 4
; Folding = z
; EnableXP