﻿; ****************************************************************************************************
; PROJECT       : TUTO_POO
; PACKAGE       : TUTO_POO.model
; DESIGNED WITH : PB 5.60
; NAME          : Drawing
; VERSION       : 1
; DATE          :
; AUTHOR        : microdevWeb
; DESCRIPTION   : model of drawing
; *****************************************************************************************************
XIncludeFile "Form.pbi"
XIncludeFile "Rectangle.pbi"
XIncludeFile "Circle.pbi"
DeclareModule Drawing
  ; les méthodes publiques
  Interface Form
    ; ABSTRACT METHODS
    draw()
    mouseIsOnMe(x,y)
    whoIam()
    free()
    ; MOTHER METHODS
    getPosX()
    getPosY()
    isSelected()
    setPosX(posX)
    setPosY(posY)
    setSelected(state.b)
    
  EndInterface
  Interface Rectangle Extends Form
    getRectangleWidth()
    getRectangleHeight()
    setRectangeWidth(width)
    setRectangleHeight(height)
  EndInterface
  Interface fCircle Extends Form
    getRadius()
    setRadius(radius)
  EndInterface
  Interface Drawing
    free() ; DESTRUCTOR
    ; GETTERS
    getDrawingWidth()
    getDrawingHeight()
    ; SETTERS
    setDrawingWidth(width)
    setDrawingHeight(height)
    ; PUBLIC METHODS
    addForm(form)
    draw()
    mouseIsOnForm(x,y)
    deselectAll()
    delete()
  EndInterface
  
  Structure _struct
    *methods
    width.l
    height.l
    List myForm.Form()
  EndStructure
  Declare new(width,height)
EndDeclareModule

Module Drawing
  ;-* GETTERS
  Procedure getDrawingWidth (*this._struct)
    With *this
      ProcedureReturn \width
    EndWith
  EndProcedure
  
  Procedure getDrawingHeight (*this._struct)
    With *this
      ProcedureReturn \height
    EndWith
  EndProcedure 
  ;}
  ;-* SETTERS
  Procedure setDrawingWidth (*this._struct,width)
    With *this
      \width = width
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  Procedure setDrawingHeight (*this._struct,height)
    With *this
      \height = height
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  ;}
  ;-* PRIVATE METHODS
  
  ;}
  ;-* PUBLIC METHODS
  Procedure addForm (*this._struct,*form)
    With *this
      AddElement(\myForm())
      \myForm() = *form
    EndWith
  EndProcedure
  
  Procedure draw (*this._struct)
    With *this
      ForEach \myForm()
        \myForm()\draw()
      Next
    EndWith
  EndProcedure
  
  Procedure mouseIsOnForm(*this._struct,x,y)
    With *this
      ForEach \myForm()
        If \myForm()\mouseIsOnMe(x,y)
          ProcedureReturn \myForm()
        EndIf
      Next
      ProcedureReturn 0 
    EndWith
  EndProcedure
  
  Procedure deselectAll (*this._struct)
    With *this
      ForEach \myForm()
        \myForm()\setSelected(#False)
      Next
    EndWith
  EndProcedure
  
  Procedure delete(*this._struct)
    With *this
      ForEach \myForm()
        If \myForm()\isSelected()
          \myForm()\free()
          DeleteElement(\myForm())
          Break
        EndIf
      Next
    EndWith
  EndProcedure
  ;}
  ;-* DESTRUCTOR
  Procedure free(*this._struct)
    With *this
      ClearStructure(*this,_struct)
    EndWith
  EndProcedure
  ;}
  ;-* CONSTRUCTOR
  Procedure new(width,height)
    Protected *this._struct = AllocateStructure(_struct)
    With *this
      \methods = ?METHODS
      If Not setDrawingWidth(*this,width) : ProcedureReturn #False : EndIf
      If Not setDrawingHeight(*this,width) : ProcedureReturn #False : EndIf
      ProcedureReturn *this
    EndWith
  EndProcedure
  ;}
  DataSection
    METHODS:
    Data.i @free()
    Data.i @getDrawingWidth()
    Data.i @getDrawingHeight()
    Data.i @setDrawingWidth()
    Data.i @setDrawingHeight()
    Data.i @addForm()
    Data.i @draw()
    Data.i @mouseIsOnForm()
    Data.i @deselectAll()
    Data.i @delete()
  EndDataSection
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; CursorPosition = 53
; FirstLine = 25
; Folding = j5H+
; EnableXP