﻿; ****************************************************************************************************
; PROJECT       : TUTO_POO
; PACKAGE       : TUTO_POO.model
; DESIGNED WITH : PB 5.60
; NAME          : Rectangle
; VERSION       : 1
; DATE          :
; AUTHOR        : microdevWeb
; DESCRIPTION   :
; *****************************************************************************************************
DeclareModule Rectangle
  Structure _struct Extends Form::_struct
    width.l
    height.l
  EndStructure
  Declare new(x,y,width,height)
EndDeclareModule

Module Rectangle
  ;-* GETTERS
  Procedure getRectangleWidth (*this._struct)
    With *this
      ProcedureReturn \width
    EndWith
  EndProcedure
  
  Procedure getRectangleHeight (*this._struct)
    With *this
      ProcedureReturn \height
    EndWith
  EndProcedure
  ;}
  ;-* SETTERS
  Procedure setRectangeWidth (*this._struct,width)
    With *this
      \width = width
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  Procedure setRectangleHeight (*this._struct,height)
    With *this
      \height = height
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  ;}
  ;-* PRIVATE METHODS
  
  ;}
  ;-* ABSTRACT METHODS
    Procedure draw (*this._struct)
      With *this
        ; we take red color for differentiating the rectangles
        If \selected
          VectorSourceColor($FF0000FF)
        Else
          VectorSourceColor($FF8CB4D2)
        EndIf
        AddPathBox(\x,\y,\width,\height)
        FillPath()
      EndWith
    EndProcedure
    
    Procedure mouseIsOnMe (*this._struct,x,y)
      With *this
        If (x > = \x And x <= (\x + \width)) And (y > = \y And y <= (\y + \height))
          ProcedureReturn *this
        EndIf
        ProcedureReturn #False
      EndWith
    EndProcedure
    
    Procedure whoIam (*this._struct)
      With *this
        ProcedureReturn Form::#CIRCLE
      EndWith
    EndProcedure
    
  ;}
  ;-* PUBLIC METHODS
  
  ;}
  ;-* DESTRUCTOR is considered as a abstract method
  Procedure free(*this._struct)
    With *this
      ClearStructure(*this,_struct)
    EndWith
  EndProcedure
  ;}
  ;-* CONSTRUCTOR
  Procedure new(x,y,width,height)
    Protected *this._struct = AllocateStructure(_struct)
    With *this
      If Not Form::super(x,y,*this,?METHODS) : ProcedureReturn #False : EndIf
      If Not setRectangeWidth(*this,width) : ProcedureReturn #False : EndIf
      If Not setRectangleHeight(*this,height) : ProcedureReturn #False : EndIf
      ProcedureReturn *this
    EndWith
  EndProcedure
  ;}
  DataSection
    ; It's very important: placed on the  first places the abstract methods
    METHODS:
    ; ABSTRACT METHODS
    Data.i @draw()
    Data.i @mouseIsOnMe()
    Data.i @whoIam()
    Data.i @free()
    ; CLASSICAL METHODS
    Data.i @getRectangleWidth()
    Data.i @getRectangleHeight()
    Data.i @setRectangeWidth()
    Data.i @setRectangleHeight()
  EndDataSection
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; CursorPosition = 58
; FirstLine = 21
; Folding = Tbx-
; EnableXP