﻿; ****************************************************************************************************
; PROJECT       : TUTO_POO
; PACKAGE       : TUTO_POO.view
; DESIGNED WITH : PB 5.60
; NAME          : MainWindow
; VERSION       : 1
; DATE          :
; AUTHOR        : microdevWeb
; DESCRIPTION   : main window of software
; *****************************************************************************************************
DeclareModule MainWindow
  Declare open()
EndDeclareModule
Module MainWindow
  EnableExplicit
  UsePNGImageDecoder()
  Structure _struct
    id.l
    canvas.l
    toolBar.l
  EndStructure
  Enumeration 
    #M_SELECT
    #M_DELETE
    #M_ADD_CIRCLE
    #M_ADD_RECTANGLE
  EndEnumeration
  ; TOOLBAR IMAGES
  Global imgSelect = CatchImage(#PB_Any,?img_select)
  Global imgRectangle = CatchImage(#PB_Any,?img_add_rectangle)
  Global imgCircle = CatchImage(#PB_Any,?img_add_circle)
  Global imgDelete = CatchImage(#PB_Any,?img_deletete)
  Global this._struct
  ;-* PRIVATE FUNCTIONS
  Procedure makeToolbar()
    With this
      \toolBar = CreateToolBar(#PB_Any,WindowID(\id))
      ToolBarImageButton(#M_SELECT,ImageID(imgSelect),#PB_ToolBar_Toggle)
      ToolBarImageButton(#M_ADD_RECTANGLE,ImageID(imgRectangle),#PB_ToolBar_Toggle)
      ToolBarImageButton(#M_ADD_CIRCLE,ImageID(imgCircle),#PB_ToolBar_Toggle)
      ToolBarImageButton(#M_DELETE,ImageID(imgDelete))
    EndWith
  EndProcedure
  ;}
  ;-* EVENT MANAGEMENT
  Procedure eventToolbar()
    With this
      Select EventGadget()
        Case #M_ADD_RECTANGLE
          ; Set the state of the other toggles at false
          SetToolBarButtonState(\toolBar,#M_ADD_CIRCLE,#False)
          SetToolBarButtonState(\toolBar,#M_SELECT,#False)
          ; set mode of drawing controller
          DrawingController::Mode = DrawingController::#MODE_RECTANGLE
        Case #M_ADD_CIRCLE
          ; Set the state of the other toggles at false
          SetToolBarButtonState(\toolBar,#M_ADD_RECTANGLE,#False)
          SetToolBarButtonState(\toolBar,#M_SELECT,#False)
          ; set mode of drawing controller
          DrawingController::Mode = DrawingController::#MODE_CIRCLE
        Case #M_SELECT
          ; Set the state of the other toggles at false
          SetToolBarButtonState(\toolBar,#M_ADD_RECTANGLE,#False)
          SetToolBarButtonState(\toolBar,#M_ADD_CIRCLE,#False)
          ; set mode of drawing controller
          DrawingController::Mode = DrawingController::#MODE_SELECT
        Case #M_DELETE
          DrawingController::delete()
      EndSelect
    EndWith
  EndProcedure
  
  Procedure eventClose()
    With this
      CloseWindow(\id)
      End
    EndWith
  EndProcedure
  
  Procedure eventCanvas()
    DrawingController::eventCanvas()
  EndProcedure
  ;}
  ;-* PUBLIC FUNCTIONS
  Procedure open()
    With this
      \id = OpenWindow(#PB_Any,0,0,800,600,"TUTO POO",#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
      makeToolbar()
      \canvas = CanvasGadget(#PB_Any,0,30,800,570)
      DrawingController::draw(\canvas)
      BindEvent(#PB_Event_Menu,@eventToolbar(),\id)
      BindEvent(#PB_Event_CloseWindow,@eventClose(),\id)
      BindGadgetEvent(\canvas,@eventCanvas())
    EndWith
  EndProcedure
  ;}
  DataSection
    img_select:
    IncludeBinary "images\select.png"
    img_add_rectangle:
    IncludeBinary "images\rectangle.png"
    img_add_circle:
    IncludeBinary "images\circle.png"
    img_deletete:
    IncludeBinary "images\delete.png"
  EndDataSection
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; CursorPosition = 67
; FirstLine = 42
; Folding = -+
; EnableXP